{$APPTYPE CONSOLE}
{$O-,I-}

uses
  SysUtils, Math;

var
  fin, fout, fans: TextFile;
  i, N, k, so, eo, mo, sa, ea, d: Integer;
  a: array of Integer;

begin
  Assign(fin, ParamStr(1)); Assign(fout, ParamStr(2)); Assign(fans, ParamStr(3));
  Reset(fin); Reset(fout); Reset(fans);

  Read(fin, N, k); SetLength(a, N);
  for i := 0 to High(a) do Read(fin, a[i]);

  try
    Read(fout, so, eo, mo);
    if (so < 1) or (so > eo) or (eo > N) then begin
      Write(Format('Bad s=%d or e=%d', [so, eo]));
      Halt(1);
    end;
    if (mo < 0) or (mo > k) then begin
      Write(Format('Bad m=%d', [mo]));
      Halt(1);
    end;
    for i := 1 to mo do begin
      Read(fout, d);
      if (Abs(d) < 1) or (Abs(d) > N) then begin
        Write(Format('d=%d @ %d', [d, i]));
        Halt(1);
      end;
      Inc(a[Abs(d) - 1], Sign(d));
    end;
    for i := so + 1 to eo do
      if a[i - 1] <> a[so - 1] then begin
        Write(Format('a[%d]=%d <> a[%d]=%d', [i, a[i - 1], so, a[so - 1]]));
        Halt(1);
      end;
    Read(fans, sa, ea);
    if eo - so < ea - sa then begin
      Write(Format('len=%d instead of %d', [eo - so + 1, ea - sa + 1]));
      Halt(1);
    end else if eo - so > ea - sa then begin
      Write(Format('OOPS: len=%d is better than %d', [eo - so + 1, ea - sa + 1]));
      Halt(3);
    end;
  except
    Halt(2);
  end;

  CloseFile(fin); CloseFile(fout); CloseFile(fans);
end.
